D. Balanced Round

time limit per test

2 seconds

memory limit per test

256 megabytes

input

standard input

output

standard output

You are the author of a Codeforces round and have prepared n� problems you are going to set, problem i� having difficulty ai��. You will do the following process:

  • remove some (possibly zero) problems from the list;
  • rearrange the remaining problems in any order you wish.

A round is considered balanced if and only if the absolute difference between the difficulty of any two consecutive problems is at most k� (less or equal than k�).

What is the minimum number of problems you have to remove so that an arrangement of problems is balanced?

Input

The first line contains a single integer t� (1≤t≤10001≤�≤1000) --- the number of test cases.

The first line of each test case contains two positive integers n� (1≤n≤2⋅1051≤�≤2⋅105) and k� (1≤k≤1091≤�≤109) --- the number of problems, and the maximum allowed absolute difference between consecutive problems.

The second line of each test case contains n� space-separated integers ai�� (1≤ai≤1091≤��≤109) --- the difficulty of each problem.

Note that the sum of n� over all test cases doesn't exceed 2⋅1052⋅105.

Output

For each test case, output a single integer --- the minimum number of problems you have to remove so that an arrangement of problems is balanced.

Example

input

Copy

复制代码

7

5 1

1 2 4 5 6

1 2

10

8 3

17 3 1 20 12 5 17 12

4 2

2 4 6 8

5 3

2 3 19 10 8

3 4

1 10 5

8 1

8 3 1 4 5 10 7 3

output

Copy

复制代码
2
0
5
0
3
1
4

Note

For the first test case, we can remove the first 22 problems and construct a set using problems with the difficulties 4,5,64,5,6, with difficulties between adjacent problems equal to |5−4|=1≤1|5−4|=1≤1 and |6−5|=1≤1|6−5|=1≤1.

For the second test case, we can take the single problem and compose a round using the problem with difficulty 1010.

解题说明:此题是一道数学题,分析后能发现直接对数列排序,然后再遍历一遍找出符合两个数之间差 <= k 的元素数量是多少, 再用总数量减去符合两个数之间差 <= k 的元素最长连续数量。

cpp 复制代码
#include<bits/stdc++.h>
using namespace std;
int t, n, k, ans, temp, a[200000];
int main() 
{
	cin >> t;
	while (t--)
	{
		cin >> n >> k;
		for (int i = 0; i < n; i++)
		{
			cin >> a[i];
		}
		sort(a, a + n);
		temp = 1;
		ans = 1;
		for (int i = 1; i < n; i++) 
		{
			if (a[i] - a[i - 1] <= k)
			{
				temp++;
			}
			else
			{
				temp = 1;
			}
			ans = max(ans, temp);
		}
		cout << n - ans << '\n';
	}
	return 0;
}
相关推荐
续写烂尾5 小时前
MK SD NAND(贴片式TF卡)替代Nor Flash:1Gb容量与256Mb Nor
算法·microsoft
u0111026756 小时前
图片预览越来越占内存聊聊 URL.createObjectURL 的释放时机
图像处理·深度学习·算法·ai作画
Zane19946 小时前
同样是遍历图,为什么BFS能保证找到最短路径,DFS却不行
算法
无限码力6 小时前
2026华为OD机试真题 新系统 9月27日【坚果巧克力】
算法·华为od·华为od机考·华为od机试真题·华为od机试·华为od机考真题题解·华为社招笔试真题
samforce6 小时前
叹息之墙——人类认知 AI,终将遇到的一堵同构之墙
人工智能·深度学习·算法·哲学·认知科学
l1t6 小时前
编译测试兼容gzip并行压缩解压工具pigz
c++·算法
代码不停7 小时前
BFS算法解决FloodFill问题
算法·bfs·宽度优先
纪念 2297 小时前
C++算法(一)
开发语言·c++·算法
All for pursuit.7 小时前
【二叉树-10】114.二叉树展开为链表
数据结构·c++·算法·leetcode·链表
叠层归一研究院7 小时前
区分预算与通道诱导:Ω–L叠层体系的观测赋值与定量验证
人工智能·算法